module SKI where

data SKI where
    S :: SKI
    K :: SKI
    I :: SKI
    (:@) :: SKI -> SKI -> SKI
infixl 6 :@

instance Show SKI where
    show (S) = "S"
    show (K) = "K"
    show (I) = "I"
    show (a :@ (b :@ c)) = show a ++ "(" ++ show (b :@ c) ++ ")"
    show (a :@ b) = show a ++ show b

eval :: Int -> SKI -> SKI
eval 0 x = x   -- 첫번째 인자가 0 이면 연산을 중단합니다.
eval n (S :@ x :@ y :@ z) = eval (n-1) (x :@ z :@ (y :@ z))   -- S 연산규칙
eval n (K :@ x :@ y) = eval (n-1) x   -- K 연산규칙
eval n (I :@ x) = eval (n-1) x   -- I 연산규칙
eval n (x :@ y) = eval (n-1) $ (eval n x) :@ (eval n y)   -- 위의 연산규칙을 재귀적으로 적용시켜 줍니다. 
eval _ x = x   -- 위의 어떤 경우에도 해당되지 않는다면 연산을 중단합니다.

_trace :: Int -> SKI -> String
_trace 0 x = show x
_trace n x =
    if (show $ eval n x) == (show $ eval (n-1) x)
    then (_trace (n-1) x)
    else (_trace (n-1) x) ++ "\n--> "  ++ (show $ eval n x)

trace = putStrLn . (_trace 7)

